//-----------------------------------------------
//TUSB-0212DAM(A)phCoANZXpAPI
//Visual C++/CLI pW[
//
//2014_02_04@Ѓ^[gH
//Copyright (C) 2014 Turtle Industry Co.,Ltd.
//-----------------------------------------------

#ifndef TUSBDAM_h
#define TUSBDAM_h

using namespace System;
using namespace System::Runtime::InteropServices;

[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Device_Open(short id);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern void Tusbdam_Device_Close(short id);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Pio_Direction(short id, unsigned char dirR);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Pio_Write(short id, unsigned char dat);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Pio_Read(short id, unsigned char *dat);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Range_Set(short id, unsigned char ch, unsigned char pol, unsigned char range);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Range_Read(short id, unsigned char ch, unsigned char *pol, unsigned char *range);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Clock_Set(short id, unsigned char sel, int clock);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Cycle_Set(short id, short cycle);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Single_Out(short id, unsigned char ch, int Data);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Start(short id, unsigned char sel);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Stop(short id);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Single_Shot(short id);
[DllImport("USBDAM.DLL", CallingConvention = CallingConvention::Cdecl)]
extern short Tusbdam_Set_Memory(short id, unsigned char ch, short Size, [In] int Data[]);

static String^ Tusbdam_GetOpenErrMessage(short retcode)
{
    switch (retcode)
    {
        case 0:
            return "I܂";
        case 1:
            return "IDԍsł";
        case 3:
            return "łɃfoCX̓I[vĂ܂";
        case 4:
            return "ڑĂ䐔܂";
        case 5:
            return "I[vł܂ł";
        case 6:
            return "foCX݂܂";
        default:
            return "sȃG[ł";
    }
}

static String^ Tusbdam_GetErrMessage(short retcode)
{
    switch (retcode)
    {
        case 0:
            return "I܂";
        case 1:
            return "foCXI[vĂ܂";
        case 2:
            return "s܂";
        default:
            return "sȃG[ł";
    }
}

#endif
